
typedef unsigned long int NOiD_id;

typedef struct NOiD_fs
{
	NOiD_id id;
	NOiD_id nfo;
	NOiD_id undo;
	NOiD_id redo;
	NOiD_id back;
	NOiD_id fore;
	NOiD_id last;
	NOiD_id next;
} NOiD_fs;

NOiD_fs * NOiD_build (int , int , void * );
void * NOiD_read (NOiD_fs * , NOiD_id , NOiD_id , void * );
void * NOiD_write (NOiD_fs * , NOiD_id , NOiD_id , void * );

NOiD_id NOiD_push (NOiD_fs * ,NOiD_id ,NOiD_id );
NOiD_id NOiD_pop (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_undo (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_redo (NOiD_fs * ,NOiD_id );

NOiD_id NOiD_mk (NOiD_fs * ,NOiD_id);
NOiD_id NOiD_rm (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_add (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_sub (NOiD_fs * ,NOiD_id );

NOiD_id NOiD_fore (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_back (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_next (NOiD_fs * ,NOiD_id );
NOiD_id NOiD_last (NOiD_fs * ,NOiD_id );
